/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.UsuarioUbicacionDAO;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.entidad.UsuarioUbicacion;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Property;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author rodrigo
 */
@Repository("usuarioUbicacionDAO")
public class UsuarioUbicacionHibernateDAO extends GenericHibernateDAO<UsuarioUbicacion, Integer>
        implements UsuarioUbicacionDAO {

    @Autowired
    public UsuarioUbicacionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    public List<UsuarioUbicacion> buscarPorUsuario(Usuario usuario) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("usuario", usuario));

        return c.list();
    }

	@Override
	public List<PuntoVenta> buscarPuntoVentaPorUsuario(Usuario usuario) {
		Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("usuario", usuario));
        c.setProjection(Property.forName("puntoVenta"));
        c.createAlias("puntoVenta", "ptovta");
        c.addOrder(Order.asc("ptovta.nombpuntoventa"));
        
		return c.list();
	}
}
